from kodaiLib import *
rekigen=365;base=0;taiyo=365*4+1;taiyoho=4#顓頊暦の諸数値
def JDYtoKansi2(Y):#西暦年を顓頊暦用干支計算用値に変換
    YY=Y+55
    while YY<0: YY+=6000#負の場合は正に変更するが繰返し回数を少なくする
    return YY % 60
def sengyokuSekkiList(Y):#節気リスト作成
    JS=taiyo/taiyoho;DD=JS/24
    JD=JDateToJD([-365,2,8])+(Y+rekigen)*JS
    R=[]
    for i in range(28):R.append(int(JD));JD+=DD
    return R
uluYear=(2,4,7,10,12,15,18) #閏年（後9月）を入れる年
def searchUluuY(Y):
    for i in range(len(uluYear)):
        if Y==uluYear[i]:return 1
    return 0
def sengyokuNew(Y):#顓頊暦の1月朔日を求める
    JS=taiyo/taiyoho#太陽年
    JDstart=JDateToJD([-rekigen,2,8]) #暦元立春
    YY=int(getSekinen(Y,rekigen,base))#積年の計算
    Dm=taiyo/taiyoho*19/235           #朔望月    
    iY=int(YY/19); mY= YY % 19        #19年単位
    if YY<0: mm=(iY-1)*235   #積年が正の場合
    else: mm=iY*235          #積年が負の場合
    for i in range(mY): #閏年の場合13，平年の場合12を加算
        mm+=12+searchUluuY(i)
    YM=Dm*mm +10/24 #巳(10)の刻が朔日
    JD=JDstart+YM   #暦元立春に加える
    return JD
def searchSengyokuML(JD,ML):#月リストの検索
    for i in range(len(ML)):
        if JD>=ML[i][2] and JD<ML[i+1][2]: return i
    return -1
def searchSengyokuSekki(JD,SL):#節気リストの検索
    for i in range(len(SL)):
        if JD== SL[i]:return i
    return -1
def sengyokuMList(Year,Month):#月リストの作成
    Y=Year           # 西暦の1月と2月の場合，顓頊暦の
    if Month<3: Y-=1 # 前年の11月，12月となることがある
    Dm=taiyo/taiyoho*19/235#朔望月
    JD=sengyokuNew(Y);uflag=searchUluuY((Y+rekigen)%19)
    ML=[];M=1
    for i in range(15):#余裕をもって15ヶ月分作成
        ML.append([Y, M,int(JD)]); JD+=Dm
        if M==9 and uflag:# 後9月の追加
            ML.append([Y, -M,int(JD)]);JD+=Dm
        M+=1
        if M>12: Y+=1; M=1 # 12より大なら次の年の1月
    return ML
def sengyokuCalendar(Year,Month):#カレンダー表示
    ML=sengyokuMList(Year,Month); Y=Year
    if Month<3:Y-=1
    SL= sengyokuSekkiList(Y)         # 節気リスト
    JD=int(JDateToJD([Year,Month,1]))# 月初めのユリウス日
    k=searchSengyokuML(JD,ML)        # 月リストのサーチ
    ID=0                             # 月の日数を求める
    if Year % 4==0:ID=1 #ユリウス暦の閏年
    NumDT=DatesTable[ID][Month-1];YB=999999999; MB=9999
    print("\n西暦", strJYear(Year),Kansi(JDYtoKansi2(Year)), "%2d月" % Month)
    print("-"*30)
    for i in range(NumDT):# 月の日数分繰り返し
        k=searchSengyokuML(JD,ML);
        if YB==ML[k][0]:strYY=" "*5   # 前の年と同じなら年を表示しない
        else: strYY=strJYear(ML[k][0]);YB=ML[k][0];MB=9999
        if MB==ML[k][1]:strM="  　　" # 前の月名と同じなら月名を表示しない
        else:
            if ML[k][1]<0: strM="後%2d月" % -ML[k][1] # 月名
            else : strM="　%2d月"%ML[k][1]
            MB=ML[k][1]  # 現在の月名
        DD=JD-ML[k][2]+1 # 日付設定
        kk=searchSengyokuSekki(JD,SL)# 節気リスト検索
        if kk<0: KAN="　　"
        else: KAN=S24tab[(kk+3)%24]  # 節気文字列設定
        print("%2d" %(i+1), strYY,strM, "%2d日" % DD,Kansi(int(JD+50)),KAN)
        JD+=1 #　ユリウス日カウント日付カウント
def dspSengyokuMList(Year):#月リストの確認
    ML=sengyokuMList(Year,4)
    print("西暦", strJYear(Year))
    for k in range(len(ML)):
        if ML[k][1]<0: strM="後%2d月" % -ML[k][1] # 月名
        else : strM="　%2d月"%ML[k][1]
        YMD=JDtoJDate(ML[k][2])
        print(strM,Kansi(int(ML[k][2]+50)),
              "(%s/%02d/%02d)" %(strJYear(YMD[0]),YMD[1],YMD[2]))
    
    
#print("\n元光元年BC134の干支")
#Y=-134; M=9

#for i in range(14):
#    M+=1
#    if M>12: Y+=1;M=1
#    sengyokuCalendar(Y,M)
#dspSengyokuMList(-134)
#dspSengyokuMList(-133)

